#include "localMap.h"

localMap::localMap(IMap &f_,IVector q0_,IVector q1_,IMatrix A0_,IMatrix A1_)
{
	f=&f_;
	q0=q0_;
	q1=q1_;
	A0=A0_;
	A1=A1_;
	A1inv=gaussInverseMatrix(A1);
}

IVector localMap::image(const IVector &x,IMatrix &D) const
{
	D=A1inv*(*f)[q0+A0*x]*A0;
	IVector x0=midVector(x);
	
	// The image is computed by using the mean value theorem (this improves accuracy):
	return A1inv*((*f)(q0+A0*x0)-q1) + D*(x-x0);
}